// **** THIS FILE WAS AUTOMATICALLY GENERATED BY makeOperators.p from GridCollectionOperators.C ******
#include "CompositeGridOperators.h"

//
//          *** here are some comments ****
//
//\begin{>CompositeGridOperatorsInclude.tex}{\subsubsection{Public enumerators}} 
//\no function header:
// 
// Here are the public enumerators:
//
//
//\end{CompositeGridOperatorsInclude.tex}



//\begin{>>CompositeGridOperatorsInclude.tex}{\subsubsection{Constructors}}  
CompositeGridOperators::
CompositeGridOperators()
//===========================================================================================
//\end{CompositeGridOperatorsInclude.tex}
//===========================================================================================
{
  setup();
  mappedGridOperatorsPointer=new MappedGridOperators();   // remember to delete this!
  mappedGridOperatorWasNewed=TRUE;
}

//\begin{>>CompositeGridOperatorsInclude.tex}{}
CompositeGridOperators::
CompositeGridOperators( CompositeGrid & gridCollection0 )
//=======================================================================================
// /Description:
//   Construct a CompositeGridOperators
// /gridCollection0 (input): Associate this grid with the operators.
// /Author: WDH
//\end{CompositeGridOperatorsInclude.tex}
//=======================================================================================
{
  mappedGridOperatorsPointer=new MappedGridOperators();   // remember to delete this!
  mappedGridOperatorWasNewed=TRUE;
  updateToMatchGrid( gridCollection0 );
  setup();
}

//\begin{>>CompositeGridOperatorsInclude.tex}{}
CompositeGridOperators::
CompositeGridOperators( MappedGridOperators & op )
//=======================================================================================
// /Description:
//   Construct a CompositeGridOperators using a MappedGridOperators
// /op (input): Associate this grid with these operators.
// /Author: WDH
//\end{CompositeGridOperatorsInclude.tex}
//=======================================================================================
{
  setup();
  mappedGridOperatorsPointer=&op;
}

//===========================================================================================
// This constructor takes a grid collection and a MappedGridOperators as input
//===========================================================================================
CompositeGridOperators::
CompositeGridOperators( CompositeGrid & gridCollection0, MappedGridOperators & op)
{
  mappedGridOperatorsPointer=&op;
  updateToMatchGrid( gridCollection0 );
  setup();
}


//===========================================================================================
//  Copy constructor 
//   deep copy
//===========================================================================================
CompositeGridOperators::
CompositeGridOperators( const CompositeGridOperators & gco ) 
{
  *this=gco;   // this uses the = operator which is a deep copy
}

CompositeGridOperators::
~CompositeGridOperators()
{
  if( mappedGridOperatorWasNewed )
    delete mappedGridOperatorsPointer;  // ** only delete if it was newed ***

}

// **** this is not realyy needed here - could use base class version *****
void CompositeGridOperators::
updateToMatchGrid( CompositeGrid & gc )              
{
  GenericCompositeGridOperators::updateToMatchGrid(gc); 
}


//================================================================================
// return the MappedGridOperators object for  MappedGrid "grid"
//================================================================================
MappedGridOperators & CompositeGridOperators::
operator[]( const int grid )  const
{
  if( grid<0 || grid>=mappedGridOperators.getLength() )
  {
    cout << "CompositeGridOperators:ERROR in operator[]  argument grid is invalid" << endl;
    cout << "grid = " << grid << endl;
    cout << "mappedGridOperators.getLength() = " << mappedGridOperators.getLength() << endl;
    cout << "Perhaps you forgot to associate a CompositeGrid with the CompositeGridOperators object\n";
    cout << "Do this in the constructor of CompositeGridOperators or use updateToMatchGrid\n";
    Overture::abort("This is a fatal error");
  }    
  return (MappedGridOperators&) mappedGridOperators[grid];
}

//=======================================================================================
//   virtualConstructor
//
//  This routine should create a new object of this class and return as a pointer
//  to the base classCompositeGridOperators.
//
//  Notes:
//   o This routine is needed if this class has been derived from the base class CompositeGridOperators
//   o This routine is used by the classe MultigridCompositeGridOperators
//     in order to construct lists of this class. These classes only know about the base class
//     and so they are unable to create a "new" version of this class
//=======================================================================================
GenericCompositeGridOperators* CompositeGridOperators::
virtualConstructor()
{
  return new CompositeGridOperators();
}

/* -----  Here are some comments -----
//\begin{>>CompositeGridOperatorsInclude.tex}{\subsubsection{Derivatives x,y,z,xx,xy,xz,yy,yz,zz,laplacian,grad,div}}
GridCollectionFunction 
"derivative"(const realCompositeGridFunction & u,
           const Index & N  // =nullIndex 
         )
//==================================================================================
// /Description:
//   "derivative" equals one of x, y, z, xx, xy, xz, yy, yz, zz, laplacian, grad, div.
// /u (input): Take the derivative of this grid function.
// /N (input): evaluate the derivatives for these components.
// /return Value:
//   The derivative. 
// /Return value:
//   The derivative is returned as a new grid function. For all derivatives but {\tt grad} and {\tt div}
// the number of components in the result is equal to the number of components specified by N
//  (if N is not specified then the result will have the same number of components 
// of the grid function being differentiated). The {\tt grad} operator
// will have number of components equal to the number of space dimensions while the {\tt div}
// operator will have only one component.
//\end{GridCollectionFunctionInclude.tex} 
//==================================================================================

//\begin{>>CompositeGridOperatorsInclude.tex}{\subsubsection{Derivative coefficients}}
GridCollectionFunction 
"derivativeCoefficients"(const Index & N // =nullIndex )
//==================================================================================
// /Description:
//   "derivativeCoefficients" equals one of xCoefficients, yCoefficients, zCoefficients, 
//   xxCoefficients, xyCoefficients, xzCoefficients, yyCoefficients, yzCoefficients, zzCoefficients,
//    laplacianCoefficients, gradCoefficients, divCoefficients.
//   Compute the coefficients of the specified derivative.
// /N (input): evaluate the coefficients for these components.
// /return Value:
//   The derivative coefficients.
//\end{GridCollectionFunctionInclude.tex} 
//==================================================================================
 ----------------- */



//\begin{>>CompositeGridOperatorsInclude.tex}{\subsubsection{get}}
int CompositeGridOperators::
get( const GenericDataBase & dir, const aString & name)
//-------------------------------------------------------------------
// /Description:
//   Get from a database file
// /dir (input): get from this directory of the database.
// /name (input): the name of the grid function on the database.
//\end{CompositeGridOperatorsInclude.tex}{}
//-------------------------------------------------------------------
{
  cout << "CompositeGridOperators::get - not implemented yet!\n"; 
  return 1;
}




//===========================================================================================
// operator = is a deep copy
//===========================================================================================
CompositeGridOperators & CompositeGridOperators::
operator= ( const CompositeGridOperators & gco )
{
  if( this  )
  {
    cout << "CompositeGridOperators::operator= :ERROR: not implemented yet. You can maybe use the "
            "updateToMatchGrid function.\n";
    Overture::abort("error");
  }
  mappedGridOperators       =gco.mappedGridOperators; // this is shallow, fix! ********
  mappedGridOperatorsPointer=gco.mappedGridOperatorsPointer;
  return *this;
}

GenericCompositeGridOperators & CompositeGridOperators::
operator= ( const GenericCompositeGridOperators & gco )
{
  if( this )
  {
    cout << "CompositeGridOperators::operator= :ERROR: operator= ( const GenericCompositeGridOperators & gco )"
            "  called\n";
    Overture::abort("error");
  }
  return *this;
}


//\begin{>>CompositeGridOperatorsInclude.tex}{\subsubsection{put}}
int CompositeGridOperators::
put( GenericDataBase & dir, const aString & name) const
//==================================================================================
// /Description:
//   output onto a database file
// /dir (input): put onto this directory of the database.
// /name (input): the name of the grid function on the database.
//\end{CompositeGridOperatorsInclude.tex} 
//==================================================================================
{
  cout << " CompositeGridOperators::put - not implemented yet!\n"; 
  return 0;
}


// --------------------Boundary Condition Routines --------------------------------


// void CompositeGridOperators::
// setNumberOfBoundaryConditions(const int & number, 
// 			      const int & side,  // =forAll
// 			      const int & axis,  // =forAll
// 			      const int & grid0  // =forAll
//                              )
// //=======================================================================================
// // /Description:
// //  Indicate how many boundary conditions are to be applied on a given side
// // /number (input): specify this number of boundary conditions.
// // /side, axis (input): defines the side of the grid, by default do all sides and all axes.
// //
// //=======================================================================================
// {
//   if( grid0==forAll )
//   {
//     for( int grid=0; grid<gridCollection.numberOfGrids(); grid++ )
//       ((MappedGridOperators&)mappedGridOperators[grid]).setNumberOfBoundaryConditions(number,side,axis);
//   }
//   else
//   {
//     ((MappedGridOperators&)mappedGridOperators[grid0]).setNumberOfBoundaryConditions(number,side,axis);
//   }
// }


// void CompositeGridOperators:: 
// setBoundaryCondition(const MappedGridOperators::boundaryConditionTypes & boundaryConditionType )
// //=======================================================================================
// // /Description:
// //   Define what a given boundary condition should be.
// //   This version assigns the given boundaryConditionType to all boundaries and all components
// // /boundaryConditionType: the type of boundary condition
// //
// //=======================================================================================
// {
//   for( int grid=0; grid<gridCollection.numberOfGrids(); grid++ )
//     ((MappedGridOperators&)mappedGridOperators[grid]).setBoundaryCondition(boundaryConditionType);
// }

// void CompositeGridOperators:: 
// setBoundaryConditionValue(const real & value,  
// 			  const int & component,   // ***** get rid of this argument *****
// 			  const int & index, 
// 			  const int & side, 
// 			  const int & axis, 
// 			  const int & grid0)
// {
//   if( grid0==forAll )
//   {
//     for( int grid=0; grid<gridCollection.numberOfGrids(); grid++ )
//       ((MappedGridOperators&)mappedGridOperators[grid]).setBoundaryConditionValue(value,index,side,axis);
//   }
//   else
//   {
//     ((MappedGridOperators&)mappedGridOperators[grid0]).setBoundaryConditionValue(value,index,side,axis);
//   }
// }

real CompositeGridOperators::
sizeOf(FILE *file /* = NULL */ ) const
// =======================================================================================
// /Description:
//   Return size of this object  
//\end{GenericCompositeGridOperatorsInclude.tex}  
// =======================================================================================
{
  real size=sizeof(*this);
  size+=GenericCompositeGridOperators::sizeOf()-sizeof(GenericCompositeGridOperators);
  int grid;
  for( grid=0; grid<gridCollection.numberOfGrids(); grid++ )
    size+=(*this)[grid].sizeOf(file);

    
  return size;
}
